;  bearbeitet von Martin Clausen (mc AT rotgradpsi DOT de)
;  original Source Code von Dirk Lieberwirth

I2CLCD      EQU 070H      ;Adresse des PCF8576

;  Die folgende Routine initialisiert den PCF8576

Init_LCD:
   ACALL  I2C_STRT
   MOV    A,#I2CLCD
   ACALL  I2C_WBYT
   MOV    A,#0E0H    ; Lade 11100000B, also: C=1 (weiteres Commando folgt)
                     ;                       device select: A0 - A2 = 0
   ACALL  I2C_WBYT
   MOV    A,#0C8H    ; Lade 11001000B, also: C=1
                     ;                       LP=1 (Chip an)
                     ;                       E=0 (Display enable)
                     ;                       B=0 (1/3 bias)
                     ;                       M=00 (mux 1:4, 4 BP)
   ACALL  I2C_WBYT
   MOV    A,#000H    ; Lade 00000000B, also: C=0 (letztes Commando)
                     ;                       data pointer = 0
   ACALL  I2C_WBYT
   ACALL  I2C_STOP
   RET

;  Zuordnung der Segmente
;  Eine Tabelle ordnet den ASCII Codes von 020h bis 05fh (Grobuchstaben, Ziffern und
;  Sonderzeichen) den Segmenten zu. Je zwei Byte ergeben ein Zeichen in der Anzeige.

Send_LCD:               ;Sende Hex-Zahl an PCF8576; Zeichen in A
   PUSH   ACC
   ACALL  I2C_STRT
   MOV    A, #I2CLCD    ;Adresse Laden
   ACALL  I2C_WBYT      ;LCD  auswhlen
   MOV    A, Position
   ACALL  I2C_WBYT      ;Wert bertragen
   POP    ACC
   CLR    C
   RLC    A             ;Mul 2 wegen zwei Werten pro Stelle
   PUSH   ACC
   MOV    DPTR, #Segmente
   MOVC   A, @A+DPTR
   ACALL  I2C_WBYT
   POP    ACC
   INC    A
   MOVC   A, @A+DPTR
   ACALL  I2C_WBYT
   ACALL  I2C_STOP
   RET

;  Die Tabelle

Segmente:
                db      000h, 000h ;
                db      001h, 020h ; ! XXX
                db      080h, 020h ; "
                db      025h, 03dh ; # XXX
                db      0adh, 0b5h ; $ X
                db      0ech, 037h ; % X
                db      03bh, 071h ; & XXX
                db      000h, 002h ; '
                db      000h, 042h ; (
                db      042h, 000h ; )
                db      066h, 066h ; *
                db      024h, 024h ; +
                db      040h, 000h ; ,
                db      020h, 004h ; -
                db      001h, 000h ; .
                db      040h, 002h ; /
                db      099h, 099h ; 0 gleich dem O
                db      000h, 009h ; 1
                db      039h, 09Ch ; 2
                db      029h, 09Dh ; 3
                db      0A0h, 00Dh ; 4
                db      0A9h, 095h ; 5
                db      0B9h, 095h ; 6
                db      008h, 089h ; 7
                db      0B9h, 09Dh ; 8
                db      0A9h, 09Dh ; 9
                db      028h, 000h ; : XXX
                db      048h, 000h ; ; XXX
                db      041h, 012h ; < XX
                db      021h, 014h ; = XXX
                db      003h, 050h ; > XX
                db      08ch, 08ch ; ?
                db      03dh, 099h ; @
                db      0b8h, 08dh ; A
                db      00dh, 0bdh ; B
                db      099h, 090h ; C
                db      00dh, 0b9h ; D
                db      0b9h, 094h ; E
                db      0b8h, 080h ; F
                db      099h, 095h ; G
                db      0b0h, 00dh ; H
                db      00dh, 0b0h ; I
                db      01dh, 0a0h ; J
                db      0b0h, 042h ; K
                db      091h, 010h ; L
                db      092h, 00bh ; M
                db      092h, 049h ; N
                db      099h, 099h ; O
                db      0b8h, 08ch ; P
                db      099h, 0d9h ; Q
                db      0b8h, 0cch ; R
                db      0a9h, 095h ; S
                db      00ch, 0a0h ; T
                db      091h, 019h ; U
                db      0d0h, 002h ; V
                db      0d0h, 049h ; W
                db      042h, 042h ; X
                db      006h, 002h ; Y
                db      049h, 092h ; Z
                db      099h, 000h ; [
                db      002h, 040h ; \
                db      000h, 099h ; ]
                db      040h, 040h ; ^ XXX
                db      001h, 010h ; _

;  Alternative fr kleine Zahlen, entsprechend einsetzen
                db      09dh, 020h ; 0
                db      004h, 020h ; 1
                db      039h, 020h ; 2
                db      02dh, 020h ; 3
                db      0a4h, 020h ; 4
                db      0adh, 000h ; 5
                db      0bdh, 000h ; 6
                db      00ch, 020h ; 7
                db      0bdh, 020h ; 8
                db      0adh, 020h ; 9